
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bseeditablesample.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bseeditablesample.hh>
#include <bse/gsldatahandle.hh>
#include "bsecxxplugin.hh"
/* --- open --- */
static void
open_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 9 "bseeditablesample.proc"
 {
#line 11 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", "Error", NULL,
				BSE_TYPE_ERROR_TYPE, BSE_ERROR_NONE,
				SFI_PARAM_STANDARD);
#line 16 "bseeditablesample.proc"
}  }
static BseErrorType
#line 16 "bseeditablesample.proc"
open_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 19 "bseeditablesample.proc"
{
#line 20 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);
  BseErrorType error;

#line 24 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample))
    return BSE_ERROR_PROC_PARAM_INVAL;

#line 28 "bseeditablesample.proc"
  
  if (!esample->wchunk)
    error = BSE_ERROR_WAVE_NOT_FOUND;
  else if (esample->open_count)
    {
      esample->open_count++;
      error = BSE_ERROR_NONE;
    }
  else
    {
      error = gsl_wave_chunk_open (esample->wchunk);
      if (!error)
	esample->open_count++;
    }

#line 43 "bseeditablesample.proc"
  
  g_value_set_enum (out_values++, error);

  return BSE_ERROR_NONE;
}

/* --- close --- */
static void
close_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 49 "bseeditablesample.proc"
 {
#line 51 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
#line 53 "bseeditablesample.proc"
}  }
static BseErrorType
#line 53 "bseeditablesample.proc"
close_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 56 "bseeditablesample.proc"
{
#line 57 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);

#line 60 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample) || !esample->wchunk || !esample->open_count)
    return BSE_ERROR_PROC_PARAM_INVAL;

#line 64 "bseeditablesample.proc"
  
  esample->open_count--;
  if (!esample->open_count)
    gsl_wave_chunk_close (esample->wchunk);

  return BSE_ERROR_NONE;
}

/* --- get-length --- */
static void
get_length_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 72 "bseeditablesample.proc"
 {
#line 74 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(out_pspecs++) = sfi_pspec_int ("length", NULL, "Number of values",
			 1, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
#line 78 "bseeditablesample.proc"
}  }
static BseErrorType
#line 78 "bseeditablesample.proc"
get_length_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 81 "bseeditablesample.proc"
{
#line 82 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);
  GslDataCache *dcache = NULL;

#line 86 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample))
    return BSE_ERROR_PROC_PARAM_INVAL;

#line 90 "bseeditablesample.proc"
  
  if (BSE_EDITABLE_SAMPLE_OPENED (esample) && esample->wchunk)
    dcache = esample->wchunk->dcache;
  sfi_value_set_int (out_values++, dcache ? gsl_data_handle_length (dcache->dhandle) : 0);

  return BSE_ERROR_NONE;
}

/* --- get-n-channels --- */
static void
get_n_channels_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 98 "bseeditablesample.proc"
 {
#line 100 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(out_pspecs++) = sfi_pspec_int ("n-channels", NULL, "Number of channels",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
#line 104 "bseeditablesample.proc"
}  }
static BseErrorType
#line 104 "bseeditablesample.proc"
get_n_channels_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 107 "bseeditablesample.proc"
{
#line 108 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);

#line 111 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample))
    return BSE_ERROR_PROC_PARAM_INVAL;

#line 115 "bseeditablesample.proc"
  
  sfi_value_set_int (out_values++, esample->wchunk ? esample->wchunk->n_channels : 1);

  return BSE_ERROR_NONE;
}

/* --- get-osc-freq --- */
static void
get_osc_freq_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 121 "bseeditablesample.proc"
 {
#line 123 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(out_pspecs++) = bse_param_spec_freq_simple ("osc-freq", NULL, "Oscillator Frequency",
				      SFI_PARAM_STANDARD);
#line 127 "bseeditablesample.proc"
}  }
static BseErrorType
#line 127 "bseeditablesample.proc"
get_osc_freq_exec (BseProcedureClass *proc,
	const GValue      *in_values,
	GValue            *out_values)
#line 130 "bseeditablesample.proc"
{
#line 131 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);

#line 134 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample))
    return BSE_ERROR_PROC_PARAM_INVAL;

#line 138 "bseeditablesample.proc"
  
  sfi_value_set_real (out_values++, esample->wchunk ? esample->wchunk->osc_freq : BSE_KAMMER_FREQUENCY);

  return BSE_ERROR_NONE;
}

/* --- read-samples --- */
static void
read_samples_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 144 "bseeditablesample.proc"
 {
#line 146 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("voffset", NULL, "Value offset",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("sample_block", NULL, "Block of samples", BSE_TYPE_FLOAT_SEQ, SFI_PARAM_STANDARD);
#line 151 "bseeditablesample.proc"
}  }
static BseErrorType
#line 151 "bseeditablesample.proc"
read_samples_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 154 "bseeditablesample.proc"
{
#line 155 "bseeditablesample.proc"
  
  BseEditableSample *esample = (BseEditableSample*) bse_value_get_object (in_values++);
  guint              voffset = sfi_value_get_int (in_values++);
  GslDataCache *dcache = NULL;
  BseFloatSeq *fseq;
#line 160 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample))
    return BSE_ERROR_PROC_PARAM_INVAL;
  if (BSE_EDITABLE_SAMPLE_OPENED (esample) && esample->wchunk)
    dcache = esample->wchunk->dcache;
  if (!dcache || voffset >= gsl_data_handle_length (dcache->dhandle))
    {
      fseq = bse_float_seq_new ();
      bse_float_seq_resize (fseq, 1024);
    }
  else
    {
      GslDataCacheNode *dnode = (GslDataCacheNode*) gsl_data_cache_ref_node (dcache, voffset, GSL_DATA_CACHE_DEMAND_LOAD);
      guint i, l, dnode_length = dcache->node_size;

      l = dnode_length - (voffset - dnode->offset) + dcache->padding;
      l = MIN (l, gsl_data_handle_length (dcache->dhandle) - voffset);
      fseq = bse_float_seq_new ();
      bse_float_seq_resize (fseq, l);
      for (i = 0; i < l; i++)
	fseq->values[i] = dnode->data[voffset - dnode->offset + i];
      gsl_data_cache_unref_node (dcache, dnode);
    }
#line 183 "bseeditablesample.proc"
  
  g_value_take_boxed (out_values++, fseq);
  return BSE_ERROR_NONE;
}
/* --- collect-stats --- */
static void
collect_stats_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 187 "bseeditablesample.proc"
 {
#line 189 "bseeditablesample.proc"
  *(in_pspecs++) = bse_param_spec_object ("esample", "Editable Sample", NULL,
				 BSE_TYPE_EDITABLE_SAMPLE, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("voffset", NULL, "Offset of first stat block",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_real ("offset_scale", NULL, "Factor to scale voffset increments with",
			  0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("block_size", NULL, "Block size to compute stat pairs from",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("stepping", NULL, "Stepping within a stat block",
			 0, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(in_pspecs++) = sfi_pspec_int ("max_pairs", NULL, "Maximum number of (min, max) pairs to collect",
			 1, 0, G_MAXINT, 1, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("sample_block", NULL, "Block of samples", BSE_TYPE_FLOAT_SEQ, SFI_PARAM_STANDARD);
#line 202 "bseeditablesample.proc"
}  }
static BseErrorType
#line 202 "bseeditablesample.proc"
collect_stats_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 205 "bseeditablesample.proc"
{
#line 206 "bseeditablesample.proc"
  
  BseEditableSample *esample    = (BseEditableSample*) bse_value_get_object (in_values++);
  guint              voffset    = sfi_value_get_int (in_values++);
  double             offs_scale = g_value_get_double (in_values++);
  guint              block_size = sfi_value_get_int (in_values++);
  guint              stepping   = sfi_value_get_int (in_values++);
  guint              max_pairs  = sfi_value_get_int (in_values++);
  GslDataCache *dcache = NULL;
  BseFloatSeq *fseq;
#line 215 "bseeditablesample.proc"
  
  if (!BSE_IS_EDITABLE_SAMPLE (esample) || stepping < 1)
    return BSE_ERROR_PROC_PARAM_INVAL;
  if (BSE_EDITABLE_SAMPLE_OPENED (esample) && esample->wchunk)
    dcache = esample->wchunk->dcache;
  if (!dcache || voffset + block_size > gsl_data_handle_length (dcache->dhandle))
    {
      fseq = bse_float_seq_new ();
      bse_float_seq_resize (fseq, max_pairs * 2);
    }
  else
    {
      GslDataCacheNode *dnode = gsl_data_cache_ref_node (dcache, voffset, GSL_DATA_CACHE_DEMAND_LOAD);
      guint j, dnode_length = dcache->node_size;
      fseq = bse_float_seq_new();
      bse_float_seq_resize (fseq, max_pairs * 2);
      for (j = 0; j < max_pairs; j++)
	{
	  guint i, cur_offset = j * offs_scale;
	  float min = +1, max = -1;
#line 235 "bseeditablesample.proc"
	  
	  cur_offset /= stepping;
	  cur_offset = voffset + cur_offset * stepping;
#line 238 "bseeditablesample.proc"
	  
	  for (i = cur_offset; i < cur_offset + block_size; i += stepping)
	    {
	      guint pos;
	      if (i < dnode->offset || i >= dnode->offset + dnode_length)
		{
		  gsl_data_cache_unref_node (dcache, dnode);
#line 245 "bseeditablesample.proc"
		  
		  dnode = gsl_data_cache_ref_node (dcache, i, j == 0 ? GSL_DATA_CACHE_DEMAND_LOAD : GSL_DATA_CACHE_PEEK);
		  if (!dnode)
		    goto break_loops;
		}
	      pos = i - dnode->offset;
	      min = MIN (min, dnode->data[pos]);
	      max = MAX (max, dnode->data[pos]);
	    }
	  fseq->values[j * 2] = min;
	  fseq->values[j * 2 + 1] = max;
	}
      gsl_data_cache_unref_node (dcache, dnode);
    break_loops:
      bse_float_seq_resize (fseq, j * 2);
    }
#line 261 "bseeditablesample.proc"
  
  g_value_take_boxed (out_values++, fseq);
  return BSE_ERROR_NONE;
}

/* --- Export to BSE --- */
static void
__enode_open__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Open the sample for reading.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 10;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_open = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+open", 
    NULL,
    "/Methods/BseEditableSample/General/Open",
    NULL,
    __enode_open__fill_strings,
  },
  0, open_setup, open_exec, 
};
static void
__enode_close__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Close an opened sample.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 50;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_close = {
  { (BseExportNode*) &__enode_open, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+close", 
    NULL,
    "/Methods/BseEditableSample/General/Close",
    NULL,
    __enode_close__fill_strings,
  },
  0, close_setup, close_exec, 
};
static void
__enode_get_length__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Return the number of values in the sample.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 73;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_length = {
  { (BseExportNode*) &__enode_close, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+get-length", 
    NULL,
    "/Methods/BseEditableSample/General/Get Length",
    NULL,
    __enode_get_length__fill_strings,
  },
  0, get_length_setup, get_length_exec, 
};
static void
__enode_get_n_channels__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Return the number of channels in the sample.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 99;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_n_channels = {
  { (BseExportNode*) &__enode_get_length, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+get-n-channels", 
    NULL,
    "/Methods/BseEditableSample/General/Get N Channels",
    NULL,
    __enode_get_n_channels__fill_strings,
  },
  0, get_n_channels_setup, get_n_channels_exec, 
};
static void
__enode_get_osc_freq__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Return the oscillator frequency for the sample.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 122;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_osc_freq = {
  { (BseExportNode*) &__enode_get_n_channels, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+get-osc-freq", 
    NULL,
    "/Methods/BseEditableSample/General/Get Osc Freq",
    NULL,
    __enode_get_osc_freq__fill_strings,
  },
  0, get_osc_freq_setup, get_osc_freq_exec, 
};
static void
__enode_read_samples__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Read a set of samples from a specific offset.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 145;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_read_samples = {
  { (BseExportNode*) &__enode_get_osc_freq, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+read-samples", 
    NULL,
    "/Methods/BseEditableSample/General/Read Samples",
    NULL,
    __enode_read_samples__fill_strings,
  },
  0, read_samples_setup, read_samples_exec, 
};
static void
__enode_collect_stats__fill_strings (BseExportStrings *es)
{
  es->blurb = ("Collect statistics from sample blocks as (minimum, maximum) pairs.");
  es->file = "/opt/src/beast/bse/bseeditablesample.proc";
  es->line = 188;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_collect_stats = {
  { (BseExportNode*) &__enode_read_samples, BSE_EXPORT_NODE_PROC,
    "BseEditableSample+collect-stats", 
    NULL,
    "/Methods/BseEditableSample/General/Collect Stats",
    NULL,
    __enode_collect_stats__fill_strings,
  },
  0, collect_stats_setup, collect_stats_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bseeditablesample_genprc_cc (void)
{
  return (BseExportNode*) &__enode_collect_stats;
}

/*
 * Generated data ends here
 */
